// Main.c
#include <REGAN21.H>			/* Register des AN21xx	*/
#include <EZRegsHEAD.H>			/* Externe Register des AN21xx  */




//#include "ds18xxHEAD.h"
#include "searchRomHEAD.h"	 
//#include "essential_RomCommandsHEAD.h" 
#include "testHEAD.h" 
#include <stdlib.h>


#include "onewireHEAD.h"

#define NUM_OF_ROMCODES 16



// Belegung des Speichers
 unsigned char T0LED;
 unsigned char LED_BLINK;	// LED blinken lassen
 unsigned char LED_COUNT;	// Blinkende LED - Zhler nach Timer


xdata unsigned char tempB1 _at_ 0x0119;
xdata unsigned char tempB2 _at_ 0x011A;
xdata unsigned char var0 _at_ 0x011B;
xdata unsigned char var1 _at_ 0x011C;
xdata unsigned char var2 _at_ 0x011D;
xdata unsigned char var3 _at_ 0x011E;
xdata unsigned char var4 _at_ 0x011F;
xdata unsigned char var5 _at_ 0x0120;
xdata unsigned char var6 _at_ 0x0121;
xdata unsigned char var7 _at_ 0x0122;
 unsigned char  i=1;
 unsigned char  vardebug2;



  
unsigned char FoundROM_test[8];			 
unsigned char FoundROM[NUM_OF_ROMCODES][8];
unsigned char numDev, rslt, i, j; 
				 



unsigned char rslt;
unsigned char numDev;


extern unsigned char ROM_NO[8];


void warte();
unsigned char hallo();


/*------------------------------------------------
The main C function.  Program execution starts
here after stack initialization.
------------------------------------------------*/
void main()
{	EA = 0;
	// Ohne die folgenden 5 Zeilen kann das USB-Board sich nicht am USB-Port melden,
	// wenn Sie aus der IIC- Datei ein EEPROM herstellen!!!
	EUSB = 1; // Enable Firmware- USB
	USBCS = 4;
	USBIRQ = 0x1E;
	IBNIRQ = IBNIEN = TOGCTL = 0;
	EPIO[0] = 0x0A; // Enable Firmware- USB Ende


	// fr die verschiedenen Bedeutungen der Krzel siehe Technical Manual Abschnitt C-24
						 
	EA=1; // Interrupts generell frei geben 
	ET0=1; // Interrupt fr Timer 0 enablen
	CT0=0; // Quelle fr den Timer: Clck24 (=0 wre Pin T0)
	T0M=0; // Frequenz des Timers: Clock div 12 (glaube ich)
	TR0=1; // TimerRun (Timer aktivieren)

//	TL0 = 0xC0; // damit das Blinken nicht im 
//	TH0 = 0xA0; // Schneckentempo vor sich geht
TL0 = 0; /////////////////////////////////////////////////////////
TH0 = 0; 

	LED_BLINK=1; // Blinken in der Software aktivieren
	LED_COUNT=1;

	PORTACFG=0; // PortA  auf IO-konfigurieren
	PORTCCFG=0;
	OEA=0xFF;
	OEC=0xFF;




var0=0;
 


while(1){  		


	// reset search-state (no found roms)
	for (i = 0; i < NUM_OF_ROMCODES; i++)
	{
		for (j = 0; j < 8; j++) FoundROM[i][j] = 0;
	}
  	
	numDev=0;
	// begin search
	rslt = OWFirst();
	if (!OWVerify()) rslt = OWVerify(); // Try to verify presence of ROM_NO; after 2 failed attempts resign

	while (rslt)
	{			
	for (i = 0; i<8; i++)
	{	// Store found ROM-number of ROM_NO-buffer in FoundROM
			FoundROM[numDev][i] = ROM_NO[i];
	}
		numDev++;
		rslt = OWNext();
		if (!OWVerify()) rslt = OWVerify();
	}
	var0 = numDev;
//			  test();
}
					   

}
			  
unsigned char hallo(){
return 7;
}


void warte(){
unsigned char i;
OEC=0xAA;
for(i=0;i<5000;i++)OEC=0xAA;
}


//
// Timer fr ms- Zhler	(bringt die LED A4 blinken)

static void T0_isr (void) interrupt 1
{//	TL1 = 0xC0;		// L-Register laden insgesamt: 0xF831
//	TH1 = 0x07;		// H-Register laden
	TL0 = 0;		// L-Register laden insgesamt: 0xF831
	TH0 = 0;		// H-Register laden
	if (LED_BLINK)
	{
		if (LED_COUNT-- == 0)	// Zhler zurcksetzen
		{	LED_COUNT = 50;		// Schleifenzhler neu setzen
			OUTA ^= 0x10;		// LED umschalten
		}
	}
}
 
 /*  */